//
//  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//  N o t e b o o k   H a r d w a r e   C o n t r o l   A C P I   D L L
//  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//
// Fan control for Asus A8JS
// MorpheusC - ht es aber allein nie geschafft!!!

//****NOTE!!:IF YOU TURN YOUR FAN OFF MANUALLY, OVERHEATING MAY OCCUR.!!****


public static class ASUSTeK
{

    #region Notebook Asus A8JS : class A8JS

    public static class A8JS
    {

        #region Class for Asus A8JP LCD Brightness control : class BRIGHTNESS
        //
        // The class must have the name BRIGHTNESS
        //
        public static class BRIGHTNESS
        {
            // Default constants for the brightness class
            public const string description = "LCD-Beleuchtung";             // Description of current class
            public const bool default_enable = false;                                // true = By default the current class is enabled in NHC
            public const int icon = 1;                                              // 0 = Hardware icon, 1 = Brightness icon, 2 = Fan icon, 3 = Battery icon, 4 = Audio icon

            // Constants for the brightness control (NHC will need this constants)
            public const int minimum_brightness_level = 0;
            public const int maximum_brightness_level = 15;
            public const int brightness_level_step = 1;

            #region Value class for brightness_level : class BRIGHTNESS_LEVEL
            //
            public static class BRIGHTNESS_LEVEL
            {
                // Properties of the value class
                public const string description = "Current LCD brightness level";   // Description of current value
                public const bool nhc_visible = true;                               // true -> value is visible in NHC

                // Value
                public static int brightness_level = 1;                             // It must have the same name as the class (case are ignored)
            }
            //
            #endregion

            // Function to set the brightness (it must have the name set_brightness)
            public static bool set_brightness(int new_level)
            {
		ACPI.METHOD.SetValue("_SB.ATKD.SPLV", new_level);
                return true;
            }

            // Function to get and refresh the brightness level (it must have the name set_brightness)
            public static bool get_brightness(ref int level)
            {
                bool result = true;
		ACPI.METHOD.GetValue("_SB.ATKD.GPLV", ref level);     // get the brightness level
                BRIGHTNESS_LEVEL.brightness_level = level;
                return result;
            }

        }
        //
        #endregion


        #region Class for Asus A8J FAN control : class FAN
        //
			//FAN Control, or better: Try of fan control
			public static class FAN
							{
					public const string description = "Manuelle  Lftersteuerung";
					public const bool default_enable = false;
					public const int icon = 2;
				public static class FAN_ON_OFF
				{
					public const string description = "Lfter:";
					public const bool nhc_visible = true;
					public static int fan_on_off = 0;
					public const string unit = "EIN|AUS";

				public static class NHC_WRITE
				{
					public const bool nhc_write = true;
					public const int nhc_minimum_value = 0;
					public const int nhc_maximum_value = 1;
					public const int nhc_default_value = 1;

				public static bool nhc_on_write()
				{
					bool result = ACPI.NAME.Write("_TZ.PLCY",(byte)fan_on_off);
					ACPI.METHOD.Call("_TZ.TCHG");
					return result;
				}
			}
		}
	} 

    public static class Manipulate_CPU_Temp_Values {


      // true = By default the current class is enabled in NHC
      public const bool default_enable = true;
      // Description of current class
      public const string description = "Automatische Lftersteuerung";
      // 0 = Hardware icon, 1 = Brightness icon, 2 = Fan icon, 3 = Battery icon, 4 = Audio icon
      public const int icon = 2;

      public static int FAN_ON_TEMP;
      public static int FAN_OFF_TEMP;
      const int BUILT_IN_FAN_OFF_TEMP = 39;


        public static class CPUTEMP_VALUE
        {
          // Properties of the value class
          public const string description = "aktuelle CPU-Temperatur";
          public const bool nhc_visible = true;
          
          // Value
          public static int CPUTEMP_value = 0;                                // It must have the same name as the class (case are ignored)
          public const string unit = "C";                                    // Unit of value
        } 

        public static class FANON_VALUE
        {
          // Properties of the value class
          public const string description = "Lfter EIN:";
          public const bool nhc_visible = true;
          
          // Value
          public static int FANON_value = FAN_ON_TEMP;                                // It must have the same name as the class (case are ignored)
          public const string unit = "K/10";                                    // Unit of value

             public static class NHC_WRITE
                {
                    public const bool nhc_write = true;                             // true -> it is possible to change the value in NHC
                    public const int nhc_minimum_value = 3200;                        // minimum input value
                    public const int nhc_maximum_value = 3400;                        // maximum input value
                    public const int nhc_default_value = 3352;                        // default value
                    public static bool nhc_on_write()                               // Optional function - NHC will call this function if the user change the value on runtime and on NHC initialisation
                    {
                       if (FANON_value <= FAN_OFF_TEMP) {
                          FANON_value = FAN_OFF_TEMP + 1;
                       }
                       FAN_ON_TEMP = FANON_value;

                       return true;
                    }
                }
        } 

        public static class FANOFF_VALUE
        {
          // Properties of the value class
          public const string description = "Lfter AUS:";
          public const bool nhc_visible = true;
          
          // Value
          public static int FANOFF_value = FAN_OFF_TEMP;                                // It must have the same name as the class (case are ignored)
          public const string unit = "K/10";                                    // Unit of value

             public static class NHC_WRITE
                {
                    public const bool nhc_write = true;                             // true -> it is possible to change the value in NHC
                    public const int nhc_minimum_value = 3100;                        // minimum input value
                    public static int nhc_maximum_value = 3350;                        // maximum input value
                    public const int nhc_default_value = 3212;                        // default value
                    public static bool nhc_on_write()                               // Optional function - NHC will call this function if the user change the value on runtime and on NHC initialisation
                    {
                       if (FANOFF_value >= FAN_ON_TEMP) {
                          FANOFF_value = FAN_ON_TEMP - 1;
                       }
                       FAN_OFF_TEMP = FANOFF_value;

                       return true;
                    }
                }

        } 



      public const double refresh_interval = 15.2;
      public static bool refresh() {
        
	int ctmp_val = 0;
        ACPI.FIELD.Read("_TZ.THRM._TMP", ref ctmp_val);
        
        CPUTEMP_VALUE.CPUTEMP_value = (ctmp_val-2732)/10;
	  
	  
        if (ctmp_val <= FAN_OFF_TEMP) {
          ACPI.NAME.Write("_TZ.PLCY",1);
	    ACPI.METHOD.Call("_TZ.TCHG");
          
        }

        
        else if(ctmp_val >= FAN_ON_TEMP) {
          ACPI.NAME.Write("_TZ.PLCY",0);
	    ACPI.METHOD.Call("_TZ.TCHG");
        }

        return true;
      }
        //
        #endregion

    }
    //
    #endregion    
}
}